
Create_CDF_Header(char *header_filename, char *output_filename, int merge_count, int max_merge_count)
{
	int count, output,patient_record_length,result_record_length;

	int	result_lines,num_of_result_lines;

	int total = 0;

    char version_buffer[2000];
    char buffer[20000];

	char * buffer_manual;

    long h_file_stream;
	long o_file_stream;


	num_of_result_lines = atoi(lr_eval_string("{Max_Num_Result_Lines}"));

    //char * filename = "c:\\readme.txt"; 

    // Open the file with read access 
	if (merge_count == max_merge_count) {
	
		if ((h_file_stream = fopen(header_filename, "rb")) == NULL) { 
	
			lr_error_message ("Cannot open %s", header_filename); 
	
			return -1; 
	
		} 
	
		// Read until end of file 
	
		while (!feof(h_file_stream)) { 
	
			// Read 1000 bytes while maintaining a running count 
	
			count = fread(buffer, sizeof(char), sizeof(buffer), h_file_stream); 
	
			lr_output_message ("%3d read", count); 
	
			// Check for file I/O errors 
	
			if (ferror(h_file_stream)) { 
	
				lr_output_message ("Error reading file %s", header_filename); 
	
			break; 
	
			} 
	
			total += count; // Add up actual bytes read 
	
		} 
	
		// Display final total 
	
		lr_output_message ("Total number of bytes read = %d", total ); 
	
		if ((o_file_stream = fopen(output_filename, "wb")) == NULL) { 
	
			lr_error_message ("Cannot open %s", output_filename); 
	
			return -1; 
	
		}

		//Write Version
	/*	version_buffer = lr_eval_string("<?xml version="1.0" encoding="UTF-8"?>
							"<!-- edited with XMLSpy v2009 sp1 (http://www.altova.com) by H Clark (Roche Diagnostics) -->"
								"<CoSoDataFormat xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://www.roche.com/diagnostics/CDF/v1\""
								"xsi:schemaLocation="http://www.roche.com/diagnostics/CDF/v1 CoSoDataFormat.xsd\""
								"SchemaVersion="1.4.4.0" PartNumber="1" TotalParts="1" StartVersion="99" EndVersion="100">");*/

		//output = fwrite(version_buffer, sizeof(char), total, o_file_stream);
		//Write CDF Patient Header
		output = fwrite(buffer, sizeof(char), total, o_file_stream);
				 //fwrite(&sd, sizeof(struct student_data), 1, file); 
	
		total = 0;
	
		if (output > 0) {
	
			lr_output_message ("Successfully wrote a header of size %d bytes", output); 
		}
	
		/*buffer_manual = lr_eval_string("\n\r<DataSection>"
							"\n\r<Patients>"
								"\n\r<Patient Root=\"2.16.840.1.113995.4.100.2.2.01248161652036104563394360077359{Root_Part1}{Root_Part2}.01248161652036104563394360077359{Root2_Part1}{Root2_Part2}\" Extension=\"{Extension}.{Extension_SubPart}\" Change=\"{cdf_state}\">"
									"\n\r<GlobalUID>FA03C9202EF348F484C42923B21B521C</GlobalUID>"
										"\n\r<PatientPersonalData Root=\"2.16.840.1.113995.4.100.2.2.01248161652036104563394360077359{Root_Part1}{Root_Part2}.01248161652036104563394360077359{Root2_Part1}{Root2_Part2}\" Extension=\"{Extension}.{Extension_SubPart}\" Change=\"{cdf_state}\">"
											"\n\r<FirstName>PERFTEST</FirstName>"
											"\n\r<LastName>Patient-{PatientName_Serial}</LastName>"
											"\n\r<BirthDate>1980-06-26T00:00:00</BirthDate>"
												"\n\r<Gender>"
													"\n\r<TypeKey>cdf.gen.female</TypeKey>"
												"\n\r</Gender>"
											"\n\r<Contacts>"
												"\n\r<Contact Root=\"2.16.840.1.113995.4.100.2.2.01248161652036104563394360077359{Root_Part1}{Root_Part2}.01248161652036104563394360077359{Root2_Part1}{Root2_Part2}\" Extension=\"{Extension}.{Extension_SubPart}\" Change=\"{cdf_state}\">"
													"\n\r<IsEmergency>N</IsEmergency>"
												"\n\r</Contact>"
												"\n\r<Contact Root=\"2.16.840.1.113995.4.100.2.2.01248161652036104563394360077359{Root_Part1}{Root_Part2}.01248161652036104563394360077359{Root2_Part1}{Root2_Part2}\" Extension=\"{Extension}.{Extension_SubPart}\" Change=\"{cdf_state}\">"
													"\n\r<IsEmergency>Y</IsEmergency>"
												"\n\r</Contact>"
											"\n\r</Contacts>"
							"\n\r</PatientPersonalData>"
						"\n\r<Results>");

			// Close the file stream 

	if (fclose(h_file_stream)) 
		{

			lr_error_message ("Error closing file %s", header_filename); 

		}

	} //terminate loop for header and result qualifier info
		//Write CDF Patient Data
	
		patient_record_length = strlen(buffer_manual);
	
		output = fwrite(buffer_manual, sizeof(char), patient_record_length, o_file_stream);
				 //fwrite(&sd, sizeof(struct student_data), 1, file); 
	
		total += output; // Add up actual bytes wrote 
	
		if (output > 0) {
	
			lr_output_message ("Successfully wrote a patient record of size %d bytes", total); 
		}
	
		total = 0;
	
	
		for (result_lines = num_of_result_lines; result_lines >= 0; result_lines--) 
	
			{
				buffer_manual = lr_eval_string("\n\r<Result Root=\"2.16.840.1.113995.4.100.2.2.01248161652036104563394360077359{Root_Part1}{Root_Part2}.01248161652036104563394360077359{Root2_Part1}{Root2_Part2}\" Extension=\"{Extension}.{Extension_SubPart}\" Change=\"{cdf_state}\">"
													"\n\r<ResultType>"
														"\n\r<TypeKey>cdf.res.measurement</TypeKey>"
													"\n\r</ResultType>"
													"\n\r<ResultDate>"
														"\n\r<DateTime>2008-02-13T04:10:49</DateTime>"
													"\n\r</ResultDate>"
													"\n\r<DataValue>0</DataValue>"
													"\n\r<HasValue>N</HasValue>"
													"\n\r<IsAnnotated>N</IsAnnotated>"
													"\n\r<IsEdited>N</IsEdited>"
													"\n\r<DataSourceType>"
														"\n\r<TypeKey>cdf.dsrc.device.insulinpump</TypeKey>"
													"\n\r</DataSourceType>"
													"\n\r<DataSourceIdentity>79/2030670</DataSourceIdentity>"
													"\n\r<DataType>"
														"\n\r<TypeKey>cdf.dat.bg</TypeKey>"
													"\n\r</DataType>"
													"\n\r<RelatedResults>"
														"\n\r<Result Root=\"2.16.840.1.113995.4.100.2.2.01248161652036104563394360077359{Root_Part1}{Root_Part2}.01248161652036104563394360077359{Root2_Part1}{Root2_Part2}\" Extension=\"{Extension}.{Extension_SubPart}\" Change=\"{cdf_state}\">"
															"\n\r<ResultType>"
																"\n\r<TypeKey>cdf.res.monitoring.upr.bolus</TypeKey>"
															"\n\r</ResultType>"
															"\n\r<ResultDate>"
																"\n\r<DateTime>2008-02-13T04:10:49</DateTime>"
															"\n\r</ResultDate>"
															"\n\r<DataValue>1</DataValue>"
															"\n\r<HasValue>Y</HasValue>"
															"\n\r<IsAnnotated>N</IsAnnotated>"
															"\n\r<IsEdited>N</IsEdited>"
															"\n\r<DataSourceType>"
																"\n\r<TypeKey>cdf.dsrc.device.insulinpump</TypeKey>"
															"\n\r</DataSourceType>"
															"\n\r<DataSourceIdentity>79/2030670</DataSourceIdentity>"
															"\n\r<DataType>"
																"\n\r<TypeKey>cdf.dat.insulin.dose</TypeKey>"
															"\n\r</DataType>"
														"\n\r</Result>"
													"\n\r</RelatedResults>"
												"\n\r</Result>");
			
	
				//Write Results
				result_record_length = strlen(buffer_manual);
			
				output = fwrite(buffer_manual, sizeof(char), result_record_length, o_file_stream);
						 //fwrite(&sd, sizeof(struct student_data), 1, file); 
			
				total += output; // Add up actual bytes wrote 	
	
				if (output > 0) {
			
					lr_output_message ("Successfully wrote a result record of size %d bytes", total); 
				}
			
				total = 0;
	
				lr_output_message ("Successfully wrote a result record number %d ", result_lines); 
	
		}
	
		buffer_manual = lr_eval_string("\n\r</Results>"
									"\n\r</Patient>");
								
	
		//Close Results Node
		result_record_length = strlen(buffer_manual);
	
		output = fwrite(buffer_manual, sizeof(char), result_record_length, o_file_stream);
				 //fwrite(&sd, sizeof(struct student_data), 1, file); 
	
		total += output; // Add up actual bytes wrote 
	
		if (output > 0) {
	
			lr_output_message ("Successfully closed a result record of size %d bytes", total); 
		}
	
		total = 0;*/

	// Close the file stream 

	/*if (merge_count == 0) {

		buffer_manual = lr_eval_string("\n\r</Patients>"
							"\n\r</DataSection>"
						"\n\r</CoSoDataFormat>");*/

		if (fclose(o_file_stream)) {
	
			lr_error_message ("Error closing file %s", output_filename); 
	
		}
	}
	return 0;
}

